// cpp(meta datanetwork format) source file CTree.cpp generated from diagram CTree
// generated on Wed Mar 17 18:23:26 2004

#include "CTree.h"
#include "UmlExt.h"

#include "UdmStatic.h"

namespace CTree {

	Uml::Diagram umldiagram;

	Uml::Class RootConnection::meta;
	Uml::Class Root::meta;
	Uml::Class CTreeModel::meta;
	Uml::Class Connection::meta;
	Uml::Class Classification::meta;
	Uml::Class Composition::meta;
	Uml::Class Class::meta;
	Uml::Class FCO::meta;
	Uml::Class CTE::meta;
	Uml::Class InputData::meta;
	Uml::Class OutputData::meta;
	Uml::Class DataContainsConnection::meta;
	Uml::Class Helper::meta;
	Uml::Class DataConnection::meta;
	Uml::Class DataFCO::meta;
	Uml::Class RootFolder::meta;
	Uml::Class MgaObject::meta;
	Uml::Attribute Root::meta_StartTime;
	Uml::Attribute Root::meta_Solver;
	Uml::Attribute Root::meta_StopTime;
	Uml::Attribute Root::meta_FixedStep;
	Uml::Attribute Classification::meta_order;
	Uml::Attribute Classification::meta_classificationType;
	Uml::Attribute Composition::meta_compositionType;
	Uml::Attribute CTE::meta_name;
	Uml::Attribute OutputData::meta_currentValue;
	Uml::Attribute Helper::meta_strTemp2;
	Uml::Attribute Helper::meta_strTemp1;
	Uml::Attribute Helper::meta_intTemp1;
	Uml::Attribute Helper::meta_intTemp2;
	Uml::Attribute DataFCO::meta_dataType;
	Uml::Attribute DataFCO::meta_scope;
	Uml::Attribute DataFCO::meta_varName;
	Uml::Attribute DataFCO::meta_action;
	Uml::Attribute RootFolder::meta_name;
	Uml::Attribute MgaObject::meta_position;
	Uml::Attribute MgaObject::meta_name;
	Uml::AssociationRole RootConnection::meta_dstRootConnection_end_;
	Uml::AssociationRole RootConnection::meta_srcRootConnection_end_;
	Uml::AssociationRole Root::meta_dstRootConnection, Root::meta_dstRootConnection_rev;
	Uml::AssociationRole Connection::meta_srcConnection_end_;
	Uml::AssociationRole Connection::meta_dstConnection_end_;
	Uml::AssociationRole Classification::meta_srcDataConnection, Classification::meta_srcDataConnection_rev;
	Uml::AssociationRole Composition::meta_srcDataContainsConnection, Composition::meta_srcDataContainsConnection_rev;
	Uml::AssociationRole FCO::meta_srcRootConnection, FCO::meta_srcRootConnection_rev;
	Uml::AssociationRole FCO::meta_dstConnection, FCO::meta_dstConnection_rev;
	Uml::AssociationRole FCO::meta_srcConnection, FCO::meta_srcConnection_rev;
	Uml::AssociationRole DataContainsConnection::meta_dstDataContainsConnection_end_;
	Uml::AssociationRole DataContainsConnection::meta_srcDataContainsConnection_end_;
	Uml::AssociationRole DataConnection::meta_dstDataConnection_end_;
	Uml::AssociationRole DataConnection::meta_srcDataConnection_end_;
	Uml::AssociationRole DataFCO::meta_dstDataConnection, DataFCO::meta_dstDataConnection_rev;
	Uml::AssociationRole DataFCO::meta_dstDataContainsConnection, DataFCO::meta_dstDataContainsConnection_rev;
	Uml::CompositionParentRole RootConnection::meta_CTreeModel_parent;
	Uml::CompositionParentRole Root::meta_CTreeModel_parent;
	Uml::CompositionParentRole CTreeModel::meta_CTE_parent;
	Uml::CompositionParentRole Connection::meta_CTreeModel_parent;
	Uml::CompositionParentRole FCO::meta_CTreeModel_parent;
	Uml::CompositionParentRole CTE::meta_RootFolder_parent;
	Uml::CompositionParentRole DataContainsConnection::meta_CTreeModel_parent;
	Uml::CompositionParentRole Helper::meta_CTreeModel_parent;
	Uml::CompositionParentRole DataConnection::meta_CTreeModel_parent;
	Uml::CompositionParentRole DataFCO::meta_CTreeModel_parent;
	Uml::CompositionParentRole RootFolder::meta_RootFolder_parent;
	Uml::CompositionChildRole CTreeModel::meta_Connection_children;
	Uml::CompositionChildRole CTreeModel::meta_RootConnection_children;
	Uml::CompositionChildRole CTreeModel::meta_Root_child;
	Uml::CompositionChildRole CTreeModel::meta_FCO_children;
	Uml::CompositionChildRole CTreeModel::meta_Helper_children;
	Uml::CompositionChildRole CTreeModel::meta_DataFCO_children;
	Uml::CompositionChildRole CTreeModel::meta_DataContainsConnection_children;
	Uml::CompositionChildRole CTreeModel::meta_DataConnection_children;
	Uml::CompositionChildRole CTE::meta_CTreeModel_children;
	Uml::CompositionChildRole RootFolder::meta_RootFolder_children;
	Uml::CompositionChildRole RootFolder::meta_CTE_children;
	Uml::Constraint RootConnection::meta_RootCombinationConstraint;
	Uml::Constraint Connection::meta_ClassificationConstraint;
	Uml::Constraint Connection::meta_CheckSelfConnections;
	Uml::Constraint Connection::meta_ClassConstraint;
	Uml::Constraint Connection::meta_CompositionConstraint;
	Uml::Constraint FCO::meta_Constraint;
	void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		 Uml::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(Uml::diagram);
		meta_dn->CreateNew("CTree.mem", "", Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="CTree";
		RootConnection::meta = Uml::Class::Create(umldiagram);
		Root::meta = Uml::Class::Create(umldiagram);
		CTreeModel::meta = Uml::Class::Create(umldiagram);
		Connection::meta = Uml::Class::Create(umldiagram);
		Classification::meta = Uml::Class::Create(umldiagram);
		Composition::meta = Uml::Class::Create(umldiagram);
		Class::meta = Uml::Class::Create(umldiagram);
		FCO::meta = Uml::Class::Create(umldiagram);
		CTE::meta = Uml::Class::Create(umldiagram);
		InputData::meta = Uml::Class::Create(umldiagram);
		OutputData::meta = Uml::Class::Create(umldiagram);
		DataContainsConnection::meta = Uml::Class::Create(umldiagram);
		Helper::meta = Uml::Class::Create(umldiagram);
		DataConnection::meta = Uml::Class::Create(umldiagram);
		DataFCO::meta = Uml::Class::Create(umldiagram);
		RootFolder::meta = Uml::Class::Create(umldiagram);
		MgaObject::meta = Uml::Class::Create(umldiagram);
		RootConnection::meta_RootCombinationConstraint = Uml::Constraint::Create(RootConnection::meta);
		Root::meta_StartTime = Uml::Attribute::Create(Root::meta);
		Root::meta_Solver = Uml::Attribute::Create(Root::meta);
		Root::meta_StopTime = Uml::Attribute::Create(Root::meta);
		Root::meta_FixedStep = Uml::Attribute::Create(Root::meta);
		Connection::meta_ClassificationConstraint = Uml::Constraint::Create(Connection::meta);
		Connection::meta_CheckSelfConnections = Uml::Constraint::Create(Connection::meta);
		Connection::meta_ClassConstraint = Uml::Constraint::Create(Connection::meta);
		Connection::meta_CompositionConstraint = Uml::Constraint::Create(Connection::meta);
		Classification::meta_order = Uml::Attribute::Create(Classification::meta);
		Classification::meta_classificationType = Uml::Attribute::Create(Classification::meta);
		Composition::meta_compositionType = Uml::Attribute::Create(Composition::meta);
		FCO::meta_Constraint = Uml::Constraint::Create(FCO::meta);
		CTE::meta_name = Uml::Attribute::Create(CTE::meta);
		OutputData::meta_currentValue = Uml::Attribute::Create(OutputData::meta);
		Helper::meta_strTemp2 = Uml::Attribute::Create(Helper::meta);
		Helper::meta_strTemp1 = Uml::Attribute::Create(Helper::meta);
		Helper::meta_intTemp1 = Uml::Attribute::Create(Helper::meta);
		Helper::meta_intTemp2 = Uml::Attribute::Create(Helper::meta);
		DataFCO::meta_dataType = Uml::Attribute::Create(DataFCO::meta);
		DataFCO::meta_scope = Uml::Attribute::Create(DataFCO::meta);
		DataFCO::meta_varName = Uml::Attribute::Create(DataFCO::meta);
		DataFCO::meta_action = Uml::Attribute::Create(DataFCO::meta);
		RootFolder::meta_name = Uml::Attribute::Create(RootFolder::meta);
		MgaObject::meta_position = Uml::Attribute::Create(MgaObject::meta);
		MgaObject::meta_name = Uml::Attribute::Create(MgaObject::meta);
		Uml::InitDiagram(umldiagram, "CTree");

		RootConnection::meta.name() = "RootConnection";
		RootConnection::meta.isAbstract() = false;
		RootConnection::meta.stereotype() = "Connection";
		Root::meta.name() = "Root";
		Root::meta.isAbstract() = false;
		Root::meta.stereotype() = "Atom";
		CTreeModel::meta.name() = "CTreeModel";
		CTreeModel::meta.isAbstract() = false;
		CTreeModel::meta.stereotype() = "Model";
		Connection::meta.name() = "Connection";
		Connection::meta.isAbstract() = false;
		Connection::meta.stereotype() = "Connection";
		Classification::meta.name() = "Classification";
		Classification::meta.isAbstract() = false;
		Classification::meta.stereotype() = "Atom";
		Composition::meta.name() = "Composition";
		Composition::meta.isAbstract() = false;
		Composition::meta.stereotype() = "Atom";
		Class::meta.name() = "Class";
		Class::meta.isAbstract() = false;
		Class::meta.stereotype() = "Atom";
		FCO::meta.name() = "FCO";
		FCO::meta.isAbstract() = true;
		FCO::meta.stereotype() = "FCO";
		CTE::meta.name() = "CTE";
		CTE::meta.isAbstract() = false;
		CTE::meta.stereotype() = "Folder";
		InputData::meta.name() = "InputData";
		InputData::meta.isAbstract() = false;
		InputData::meta.stereotype() = "Atom";
		OutputData::meta.name() = "OutputData";
		OutputData::meta.isAbstract() = false;
		OutputData::meta.stereotype() = "Atom";
		DataContainsConnection::meta.name() = "DataContainsConnection";
		DataContainsConnection::meta.isAbstract() = false;
		DataContainsConnection::meta.stereotype() = "Connection";
		Helper::meta.name() = "Helper";
		Helper::meta.isAbstract() = false;
		Helper::meta.stereotype() = "Atom";
		DataConnection::meta.name() = "DataConnection";
		DataConnection::meta.isAbstract() = false;
		DataConnection::meta.stereotype() = "Connection";
		DataFCO::meta.name() = "DataFCO";
		DataFCO::meta.isAbstract() = true;
		DataFCO::meta.stereotype() = "FCO";
		RootFolder::meta.name() = "RootFolder";
		RootFolder::meta.isAbstract() = false;
		RootFolder::meta.stereotype() = "Folder";
		MgaObject::meta.name() = "MgaObject";
		MgaObject::meta.isAbstract() = true;
		
		RootConnection::meta_RootCombinationConstraint.name() = "RootCombinationConstraint";
		RootConnection::meta_RootCombinationConstraint.description() = "The root node may not combined with the selected node!";
		RootConnection::meta_RootCombinationConstraint.expression() = "self.connectionPoints(\"dst\")->theOnly().target().oclIsKindOf(Classification) ||\nself.connectionPoints(\"dst\")->theOnly().target().oclIsTypeOf(Composition)";
		vector<string> Root_StartTime_dva;
		Root_StartTime_dva.push_back("0.0");
		Root::meta_StartTime.name() = "StartTime";
		Root::meta_StartTime.type() = "String";
		Root::meta_StartTime.min() = 1;
		Root::meta_StartTime.max() = 1;
		Root::meta_StartTime.nonpersistent() = false;
		Root::meta_StartTime.registry() = false;
		Root::meta_StartTime.ordered() = false;
		Root::meta_StartTime.visibility() = "public";
		Root::meta_StartTime.defvalue() = Root_StartTime_dva;
		Root::meta_Solver.name() = "Solver";
		Root::meta_Solver.type() = "String";
		Root::meta_Solver.min() = 1;
		Root::meta_Solver.max() = 1;
		Root::meta_Solver.nonpersistent() = false;
		Root::meta_Solver.registry() = false;
		Root::meta_Solver.ordered() = false;
		Root::meta_Solver.visibility() = "public";
		Root::meta_Solver.defvalue() = vector<string>();
		vector<string> Root_StopTime_dva;
		Root_StopTime_dva.push_back("10");
		Root::meta_StopTime.name() = "StopTime";
		Root::meta_StopTime.type() = "String";
		Root::meta_StopTime.min() = 1;
		Root::meta_StopTime.max() = 1;
		Root::meta_StopTime.nonpersistent() = false;
		Root::meta_StopTime.registry() = false;
		Root::meta_StopTime.ordered() = false;
		Root::meta_StopTime.visibility() = "public";
		Root::meta_StopTime.defvalue() = Root_StopTime_dva;
		vector<string> Root_FixedStep_dva;
		Root_FixedStep_dva.push_back("1");
		Root::meta_FixedStep.name() = "FixedStep";
		Root::meta_FixedStep.type() = "String";
		Root::meta_FixedStep.min() = 1;
		Root::meta_FixedStep.max() = 1;
		Root::meta_FixedStep.nonpersistent() = false;
		Root::meta_FixedStep.registry() = false;
		Root::meta_FixedStep.ordered() = false;
		Root::meta_FixedStep.visibility() = "public";
		Root::meta_FixedStep.defvalue() = Root_FixedStep_dva;
		Connection::meta_ClassificationConstraint.name() = "ClassificationConstraint";
		Connection::meta_ClassificationConstraint.description() = "Classification may only be connected to Composition or Class objects!";
		Connection::meta_ClassificationConstraint.expression() = "if self.connectionPoints(\"src\")->theOnly().target().oclIsKindOf(Classification) then\nself.connectionPoints(\"dst\")->theOnly().target().oclIsTypeOf(Class)\nelse true endif";
		Connection::meta_CheckSelfConnections.name() = "CheckSelfConnections";
		Connection::meta_CheckSelfConnections.description() = "Nodes are not allowed to be connected with themself!";
		Connection::meta_CheckSelfConnections.expression() = "self.connectionPoints( \"src\" )->theOnly().target() <>\nself.connectionPoints( \"dst\" )->theOnly().target()";
		Connection::meta_ClassConstraint.name() = "ClassConstraint";
		Connection::meta_ClassConstraint.description() = "Klasses may only be connected to Klassifikations or Kompositions!";
		Connection::meta_ClassConstraint.expression() = "if self.connectionPoints(\"src\")->theOnly().target().oclIsTypeOf(Class) then\nself.connectionPoints(\"dst\")->theOnly().target().oclIsTypeOf(Classification) ||\nself.connectionPoints(\"dst\")->theOnly().target().oclIsTypeOf(Composition)\nelse true endif";
		Connection::meta_CompositionConstraint.name() = "CompositionConstraint";
		Connection::meta_CompositionConstraint.description() = "Kompositions may only be connected to Kompositions or Klassifikations!";
		Connection::meta_CompositionConstraint.expression() = "if self.connectionPoints(\"src\")->theOnly().target().oclIsTypeOf(Composition) then\nself.connectionPoints(\"dst\")->theOnly().target().oclIsTypeOf(Composition) ||\nself.connectionPoints(\"dst\")->theOnly().target().oclIsKindOf(Classification)\nelse true endif";
		vector<string> Classification_order_dva;
		Classification_order_dva.push_back("-1");
		Classification::meta_order.name() = "order";
		Classification::meta_order.type() = "Integer";
		Classification::meta_order.min() = 1;
		Classification::meta_order.max() = 1;
		Classification::meta_order.nonpersistent() = false;
		Classification::meta_order.registry() = false;
		Classification::meta_order.ordered() = false;
		Classification::meta_order.visibility() = "public";
		Classification::meta_order.defvalue() = Classification_order_dva;
		vector<string> Classification_classificationType_dva;
		Classification_classificationType_dva.push_back("other");
		Classification::meta_classificationType.name() = "classificationType";
		Classification::meta_classificationType.type() = "String";
		Classification::meta_classificationType.min() = 1;
		Classification::meta_classificationType.max() = 1;
		Classification::meta_classificationType.nonpersistent() = false;
		Classification::meta_classificationType.registry() = false;
		Classification::meta_classificationType.ordered() = false;
		Classification::meta_classificationType.visibility() = "public";
		Classification::meta_classificationType.defvalue() = Classification_classificationType_dva;
		vector<string> Composition_compositionType_dva;
		Composition_compositionType_dva.push_back("other");
		Composition::meta_compositionType.name() = "compositionType";
		Composition::meta_compositionType.type() = "String";
		Composition::meta_compositionType.min() = 1;
		Composition::meta_compositionType.max() = 1;
		Composition::meta_compositionType.nonpersistent() = false;
		Composition::meta_compositionType.registry() = false;
		Composition::meta_compositionType.ordered() = false;
		Composition::meta_compositionType.visibility() = "public";
		Composition::meta_compositionType.defvalue() = Composition_compositionType_dva;
		FCO::meta_Constraint.name() = "Constraint";
		FCO::meta_Constraint.description() = "Node connection cardinallity is wrong!";
		FCO::meta_Constraint.expression() = "let rootDstCount = self.attachingConnections( \"dst\", RootConnection ) -> size in\nlet nodeDstCount = self.attachingConnections( \"dst\", Connection ) -> size in\n(rootDstCount <> nodeDstCount) && (rootDstCount <= 1) && (nodeDstCount  <= 1)\n";
		CTE::meta_name.name() = "name";
		CTE::meta_name.type() = "String";
		CTE::meta_name.min() = 0;
		CTE::meta_name.max() = 1;
		CTE::meta_name.nonpersistent() = false;
		CTE::meta_name.registry() = false;
		CTE::meta_name.ordered() = false;
		CTE::meta_name.visibility() = "public";
		CTE::meta_name.defvalue() = vector<string>();
		vector<string> OutputData_currentValue_dva;
		OutputData_currentValue_dva.push_back("1");
		OutputData::meta_currentValue.name() = "currentValue";
		OutputData::meta_currentValue.type() = "Integer";
		OutputData::meta_currentValue.min() = 1;
		OutputData::meta_currentValue.max() = 1;
		OutputData::meta_currentValue.nonpersistent() = false;
		OutputData::meta_currentValue.registry() = false;
		OutputData::meta_currentValue.ordered() = false;
		OutputData::meta_currentValue.visibility() = "public";
		OutputData::meta_currentValue.defvalue() = OutputData_currentValue_dva;
		Helper::meta_strTemp2.name() = "strTemp2";
		Helper::meta_strTemp2.type() = "String";
		Helper::meta_strTemp2.min() = 1;
		Helper::meta_strTemp2.max() = 1;
		Helper::meta_strTemp2.nonpersistent() = false;
		Helper::meta_strTemp2.registry() = false;
		Helper::meta_strTemp2.ordered() = false;
		Helper::meta_strTemp2.visibility() = "public";
		Helper::meta_strTemp2.defvalue() = vector<string>();
		Helper::meta_strTemp1.name() = "strTemp1";
		Helper::meta_strTemp1.type() = "String";
		Helper::meta_strTemp1.min() = 1;
		Helper::meta_strTemp1.max() = 1;
		Helper::meta_strTemp1.nonpersistent() = false;
		Helper::meta_strTemp1.registry() = false;
		Helper::meta_strTemp1.ordered() = false;
		Helper::meta_strTemp1.visibility() = "public";
		Helper::meta_strTemp1.defvalue() = vector<string>();
		vector<string> Helper_intTemp1_dva;
		Helper_intTemp1_dva.push_back("0");
		Helper::meta_intTemp1.name() = "intTemp1";
		Helper::meta_intTemp1.type() = "Integer";
		Helper::meta_intTemp1.min() = 1;
		Helper::meta_intTemp1.max() = 1;
		Helper::meta_intTemp1.nonpersistent() = false;
		Helper::meta_intTemp1.registry() = false;
		Helper::meta_intTemp1.ordered() = false;
		Helper::meta_intTemp1.visibility() = "public";
		Helper::meta_intTemp1.defvalue() = Helper_intTemp1_dva;
		vector<string> Helper_intTemp2_dva;
		Helper_intTemp2_dva.push_back("0");
		Helper::meta_intTemp2.name() = "intTemp2";
		Helper::meta_intTemp2.type() = "Integer";
		Helper::meta_intTemp2.min() = 1;
		Helper::meta_intTemp2.max() = 1;
		Helper::meta_intTemp2.nonpersistent() = false;
		Helper::meta_intTemp2.registry() = false;
		Helper::meta_intTemp2.ordered() = false;
		Helper::meta_intTemp2.visibility() = "public";
		Helper::meta_intTemp2.defvalue() = Helper_intTemp2_dva;
		DataFCO::meta_dataType.name() = "dataType";
		DataFCO::meta_dataType.type() = "String";
		DataFCO::meta_dataType.min() = 1;
		DataFCO::meta_dataType.max() = 1;
		DataFCO::meta_dataType.nonpersistent() = false;
		DataFCO::meta_dataType.registry() = false;
		DataFCO::meta_dataType.ordered() = false;
		DataFCO::meta_dataType.visibility() = "public";
		DataFCO::meta_dataType.defvalue() = vector<string>();
		vector<string> DataFCO_scope_dva;
		DataFCO_scope_dva.push_back("LOCAL_DATA");
		DataFCO::meta_scope.name() = "scope";
		DataFCO::meta_scope.type() = "String";
		DataFCO::meta_scope.min() = 1;
		DataFCO::meta_scope.max() = 1;
		DataFCO::meta_scope.nonpersistent() = false;
		DataFCO::meta_scope.registry() = false;
		DataFCO::meta_scope.ordered() = false;
		DataFCO::meta_scope.visibility() = "public";
		DataFCO::meta_scope.defvalue() = DataFCO_scope_dva;
		DataFCO::meta_varName.name() = "varName";
		DataFCO::meta_varName.type() = "String";
		DataFCO::meta_varName.min() = 1;
		DataFCO::meta_varName.max() = 1;
		DataFCO::meta_varName.nonpersistent() = false;
		DataFCO::meta_varName.registry() = false;
		DataFCO::meta_varName.ordered() = false;
		DataFCO::meta_varName.visibility() = "public";
		DataFCO::meta_varName.defvalue() = vector<string>();
		DataFCO::meta_action.name() = "action";
		DataFCO::meta_action.type() = "String";
		DataFCO::meta_action.min() = 1;
		DataFCO::meta_action.max() = 1;
		DataFCO::meta_action.nonpersistent() = false;
		DataFCO::meta_action.registry() = false;
		DataFCO::meta_action.ordered() = false;
		DataFCO::meta_action.visibility() = "public";
		DataFCO::meta_action.defvalue() = vector<string>();
		RootFolder::meta_name.name() = "name";
		RootFolder::meta_name.type() = "String";
		RootFolder::meta_name.min() = 0;
		RootFolder::meta_name.max() = 1;
		RootFolder::meta_name.nonpersistent() = false;
		RootFolder::meta_name.registry() = false;
		RootFolder::meta_name.ordered() = false;
		RootFolder::meta_name.visibility() = "public";
		RootFolder::meta_name.defvalue() = vector<string>();
		MgaObject::meta_position.name() = "position";
		MgaObject::meta_position.type() = "String";
		MgaObject::meta_position.min() = 0;
		MgaObject::meta_position.max() = 1;
		MgaObject::meta_position.nonpersistent() = false;
		MgaObject::meta_position.registry() = false;
		MgaObject::meta_position.ordered() = false;
		MgaObject::meta_position.visibility() = "public";
		MgaObject::meta_position.defvalue() = vector<string>();
		MgaObject::meta_name.name() = "name";
		MgaObject::meta_name.type() = "String";
		MgaObject::meta_name.min() = 0;
		MgaObject::meta_name.max() = 1;
		MgaObject::meta_name.nonpersistent() = false;
		MgaObject::meta_name.registry() = false;
		MgaObject::meta_name.ordered() = false;
		MgaObject::meta_name.visibility() = "public";
		MgaObject::meta_name.defvalue() = vector<string>();
		
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			ass.name() = "RootConnection";
			ass.assocClass() = RootConnection::meta;
			FCO::meta_srcRootConnection = Uml::AssociationRole::Create(ass);
			FCO::meta_srcRootConnection.name() = "srcRootConnection";
			FCO::meta_srcRootConnection.min() = 0;
			FCO::meta_srcRootConnection.max() = -1;
			FCO::meta_srcRootConnection.isNavigable() = true;
			FCO::meta_srcRootConnection.isPrimary() = false;
			FCO::meta_srcRootConnection.target() = Root::meta;
			RootConnection::meta_srcRootConnection_end_ = Root::meta_dstRootConnection_rev = FCO::meta_srcRootConnection;
			Root::meta_dstRootConnection = Uml::AssociationRole::Create(ass);
			Root::meta_dstRootConnection.name() = "dstRootConnection";
			Root::meta_dstRootConnection.min() = 0;
			Root::meta_dstRootConnection.max() = -1;
			Root::meta_dstRootConnection.isNavigable() = true;
			Root::meta_dstRootConnection.isPrimary() = false;
			Root::meta_dstRootConnection.target() = FCO::meta;
			RootConnection::meta_dstRootConnection_end_ = FCO::meta_srcRootConnection_rev = Root::meta_dstRootConnection;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			ass.name() = "DataConnection";
			ass.assocClass() = DataConnection::meta;
			Classification::meta_srcDataConnection = Uml::AssociationRole::Create(ass);
			Classification::meta_srcDataConnection.name() = "srcDataConnection";
			Classification::meta_srcDataConnection.min() = 0;
			Classification::meta_srcDataConnection.max() = -1;
			Classification::meta_srcDataConnection.isNavigable() = true;
			Classification::meta_srcDataConnection.isPrimary() = false;
			Classification::meta_srcDataConnection.target() = DataFCO::meta;
			DataConnection::meta_srcDataConnection_end_ = DataFCO::meta_dstDataConnection_rev = Classification::meta_srcDataConnection;
			DataFCO::meta_dstDataConnection = Uml::AssociationRole::Create(ass);
			DataFCO::meta_dstDataConnection.name() = "dstDataConnection";
			DataFCO::meta_dstDataConnection.min() = 0;
			DataFCO::meta_dstDataConnection.max() = -1;
			DataFCO::meta_dstDataConnection.isNavigable() = true;
			DataFCO::meta_dstDataConnection.isPrimary() = false;
			DataFCO::meta_dstDataConnection.target() = Classification::meta;
			DataConnection::meta_dstDataConnection_end_ = Classification::meta_srcDataConnection_rev = DataFCO::meta_dstDataConnection;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			ass.name() = "DataContainsConnection";
			ass.assocClass() = DataContainsConnection::meta;
			Composition::meta_srcDataContainsConnection = Uml::AssociationRole::Create(ass);
			Composition::meta_srcDataContainsConnection.name() = "srcDataContainsConnection";
			Composition::meta_srcDataContainsConnection.min() = 0;
			Composition::meta_srcDataContainsConnection.max() = -1;
			Composition::meta_srcDataContainsConnection.isNavigable() = true;
			Composition::meta_srcDataContainsConnection.isPrimary() = false;
			Composition::meta_srcDataContainsConnection.target() = DataFCO::meta;
			DataContainsConnection::meta_srcDataContainsConnection_end_ = DataFCO::meta_dstDataContainsConnection_rev = Composition::meta_srcDataContainsConnection;
			DataFCO::meta_dstDataContainsConnection = Uml::AssociationRole::Create(ass);
			DataFCO::meta_dstDataContainsConnection.name() = "dstDataContainsConnection";
			DataFCO::meta_dstDataContainsConnection.min() = 0;
			DataFCO::meta_dstDataContainsConnection.max() = -1;
			DataFCO::meta_dstDataContainsConnection.isNavigable() = true;
			DataFCO::meta_dstDataContainsConnection.isPrimary() = false;
			DataFCO::meta_dstDataContainsConnection.target() = Composition::meta;
			DataContainsConnection::meta_dstDataContainsConnection_end_ = Composition::meta_srcDataContainsConnection_rev = DataFCO::meta_dstDataContainsConnection;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			ass.name() = "Connection";
			ass.assocClass() = Connection::meta;
			FCO::meta_dstConnection = Uml::AssociationRole::Create(ass);
			FCO::meta_dstConnection.name() = "dstConnection";
			FCO::meta_dstConnection.min() = 0;
			FCO::meta_dstConnection.max() = -1;
			FCO::meta_dstConnection.isNavigable() = true;
			FCO::meta_dstConnection.isPrimary() = false;
			FCO::meta_dstConnection.target() = FCO::meta;
			Connection::meta_dstConnection_end_ = FCO::meta_srcConnection_rev = FCO::meta_dstConnection;
			FCO::meta_srcConnection = Uml::AssociationRole::Create(ass);
			FCO::meta_srcConnection.name() = "srcConnection";
			FCO::meta_srcConnection.min() = 0;
			FCO::meta_srcConnection.max() = -1;
			FCO::meta_srcConnection.isNavigable() = true;
			FCO::meta_srcConnection.isPrimary() = false;
			FCO::meta_srcConnection.target() = FCO::meta;
			Connection::meta_srcConnection_end_ = FCO::meta_dstConnection_rev = FCO::meta_srcConnection;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Connection::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			Connection::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			Connection::meta_CTreeModel_parent.isNavigable() = true;
			Connection::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_Connection_children = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_Connection_children.name() = "Connection";
			CTreeModel::meta_Connection_children.min() = 0;
			CTreeModel::meta_Connection_children.max() = -1;
			CTreeModel::meta_Connection_children.isNavigable() = true;
			CTreeModel::meta_Connection_children.target() = Connection::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			RootConnection::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			RootConnection::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			RootConnection::meta_CTreeModel_parent.isNavigable() = true;
			RootConnection::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_RootConnection_children = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_RootConnection_children.name() = "RootConnection";
			CTreeModel::meta_RootConnection_children.min() = 0;
			CTreeModel::meta_RootConnection_children.max() = -1;
			CTreeModel::meta_RootConnection_children.isNavigable() = true;
			CTreeModel::meta_RootConnection_children.target() = RootConnection::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Root::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			Root::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			Root::meta_CTreeModel_parent.isNavigable() = true;
			Root::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_Root_child = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_Root_child.name() = "Root";
			CTreeModel::meta_Root_child.min() = 1;
			CTreeModel::meta_Root_child.max() = 1;
			CTreeModel::meta_Root_child.isNavigable() = true;
			CTreeModel::meta_Root_child.target() = Root::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			FCO::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			FCO::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			FCO::meta_CTreeModel_parent.isNavigable() = true;
			FCO::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_FCO_children = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_FCO_children.name() = "FCO";
			CTreeModel::meta_FCO_children.min() = 0;
			CTreeModel::meta_FCO_children.max() = -1;
			CTreeModel::meta_FCO_children.isNavigable() = true;
			CTreeModel::meta_FCO_children.target() = FCO::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Helper::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			Helper::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			Helper::meta_CTreeModel_parent.isNavigable() = true;
			Helper::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_Helper_children = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_Helper_children.name() = "Helper";
			CTreeModel::meta_Helper_children.min() = 0;
			CTreeModel::meta_Helper_children.max() = -1;
			CTreeModel::meta_Helper_children.isNavigable() = true;
			CTreeModel::meta_Helper_children.target() = Helper::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			DataFCO::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			DataFCO::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			DataFCO::meta_CTreeModel_parent.isNavigable() = true;
			DataFCO::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_DataFCO_children = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_DataFCO_children.name() = "DataFCO";
			CTreeModel::meta_DataFCO_children.min() = 0;
			CTreeModel::meta_DataFCO_children.max() = -1;
			CTreeModel::meta_DataFCO_children.isNavigable() = true;
			CTreeModel::meta_DataFCO_children.target() = DataFCO::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			DataContainsConnection::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			DataContainsConnection::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			DataContainsConnection::meta_CTreeModel_parent.isNavigable() = true;
			DataContainsConnection::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_DataContainsConnection_children = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_DataContainsConnection_children.name() = "DataContainsConnection";
			CTreeModel::meta_DataContainsConnection_children.min() = 0;
			CTreeModel::meta_DataContainsConnection_children.max() = -1;
			CTreeModel::meta_DataContainsConnection_children.isNavigable() = true;
			CTreeModel::meta_DataContainsConnection_children.target() = DataContainsConnection::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			DataConnection::meta_CTreeModel_parent = Uml::CompositionParentRole::Create(comp);
			DataConnection::meta_CTreeModel_parent.name() = "CTreeModel_parent";
			DataConnection::meta_CTreeModel_parent.isNavigable() = true;
			DataConnection::meta_CTreeModel_parent.target() = CTreeModel::meta;
			CTreeModel::meta_DataConnection_children = Uml::CompositionChildRole::Create(comp);
			CTreeModel::meta_DataConnection_children.name() = "DataConnection";
			CTreeModel::meta_DataConnection_children.min() = 0;
			CTreeModel::meta_DataConnection_children.max() = -1;
			CTreeModel::meta_DataConnection_children.isNavigable() = true;
			CTreeModel::meta_DataConnection_children.target() = DataConnection::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			CTreeModel::meta_CTE_parent = Uml::CompositionParentRole::Create(comp);
			CTreeModel::meta_CTE_parent.name() = "CTE_parent";
			CTreeModel::meta_CTE_parent.isNavigable() = true;
			CTreeModel::meta_CTE_parent.target() = CTE::meta;
			CTE::meta_CTreeModel_children = Uml::CompositionChildRole::Create(comp);
			CTE::meta_CTreeModel_children.name() = "CTreeModel";
			CTE::meta_CTreeModel_children.min() = 0;
			CTE::meta_CTreeModel_children.max() = -1;
			CTE::meta_CTreeModel_children.isNavigable() = true;
			CTE::meta_CTreeModel_children.target() = CTreeModel::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			RootFolder::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
			RootFolder::meta_RootFolder_parent.name() = "RootFolder_parent";
			RootFolder::meta_RootFolder_parent.isNavigable() = true;
			RootFolder::meta_RootFolder_parent.target() = RootFolder::meta;
			RootFolder::meta_RootFolder_children = Uml::CompositionChildRole::Create(comp);
			RootFolder::meta_RootFolder_children.name() = "RootFolder";
			RootFolder::meta_RootFolder_children.min() = 0;
			RootFolder::meta_RootFolder_children.max() = -1;
			RootFolder::meta_RootFolder_children.isNavigable() = true;
			RootFolder::meta_RootFolder_children.target() = RootFolder::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			CTE::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
			CTE::meta_RootFolder_parent.name() = "RootFolder_parent";
			CTE::meta_RootFolder_parent.isNavigable() = true;
			CTE::meta_RootFolder_parent.target() = RootFolder::meta;
			RootFolder::meta_CTE_children = Uml::CompositionChildRole::Create(comp);
			RootFolder::meta_CTE_children.name() = "CTE";
			RootFolder::meta_CTE_children.min() = 0;
			RootFolder::meta_CTE_children.max() = -1;
			RootFolder::meta_CTE_children.isNavigable() = true;
			RootFolder::meta_CTE_children.target() = CTE::meta;
		}
		FCO::meta.subTypes() +=  Classification::meta;
		FCO::meta.subTypes() +=  Composition::meta;
		FCO::meta.subTypes() +=  Class::meta;
		DataFCO::meta.subTypes() +=  InputData::meta;
		DataFCO::meta.subTypes() +=  OutputData::meta;
		MgaObject::meta.subTypes() +=  RootConnection::meta;
		MgaObject::meta.subTypes() +=  Root::meta;
		MgaObject::meta.subTypes() +=  CTreeModel::meta;
		MgaObject::meta.subTypes() +=  Connection::meta;
		MgaObject::meta.subTypes() +=  FCO::meta;
		MgaObject::meta.subTypes() +=  DataContainsConnection::meta;
		MgaObject::meta.subTypes() +=  Helper::meta;
		MgaObject::meta.subTypes() +=  DataConnection::meta;
		MgaObject::meta.subTypes() +=  DataFCO::meta;
		
	}
	 Udm::UdmDiagram diagram = { &umldiagram, Initialize };
	static struct _regClass
	{
		_regClass()
		{
			Udm::MetaDepository::StoreDiagram("CTree", diagram);
		};
		~_regClass()
		{
			Udm::MetaDepository::RemoveDiagram("CTree");
		};
	} __regUnUsed;

}
// END CTree.cpp
